package pencilbox.slalom;

import pencilbox.common.core.Address;
import pencilbox.common.core.BoardBase;
import pencilbox.common.gui.PanelEventHandlerBase;


/**
 * uX[v}EX^L[쏈NX
 */
public class PanelEventHandler extends PanelEventHandlerBase {

	private Board board;

	private int pressRow = -1;

	private int pressCol = -1;

	/**
	 * RXgN^
	 */
	public PanelEventHandler() {
		//setMaxInputNumber(99);
	}

	protected void setBoard(BoardBase aBoard) {
		board = (Board) aBoard;
	}

	@Override
	protected void leftPressed(Address pos) {
		if (isProblemEditMode()) {
			//ꂽ}X}Xǂ𔻒
			if (board.getNumber(pos.r(), pos.c()) >= 0) {
				//}X΂܂
				pressRow = pos.r();
				pressCol = pos.c();
			} else {
				//}X獕}Xɂ܂
				if (getCellCursor().r() == pos.r() && getCellCursor().c() == pos.c()) {
					board.setNumber(pos, 0);
				}
			}
		}
	}

	//}EX
	protected void leftDragged(Address dragStart, Address dragEnd) {
		if (isProblemEditMode()) {
			int r = dragEnd.r();
			int c = dragEnd.c();
			if (pressRow >= 0 && pressCol >= 0 && (pressRow != r || pressCol != c)) {
				if (pressRow == r) {
					if (pressCol + 1 == c && board.getNumber(pressRow, pressCol + 1) < 0) {
						board.addHGate(pressRow, pressCol + 1);
					} else if (pressCol - 1 == c && board.getNumber(pressRow, pressCol - 1) < 0) {
						board.addHGate(pressRow, pressCol - 1);
					}
				} else if (pressCol == c) {
					if (pressRow + 1 == r && board.getNumber(pressRow + 1, pressCol) < 0) {
						board.addVGate(pressRow + 1, pressCol);
					} else if (pressRow - 1 == r && board.getNumber(pressRow - 1, pressCol) < 0) {
						board.addVGate(pressRow - 1, pressCol);
					}
				}

				pressRow = -1;
				pressCol = -1;
			}
		} else {
			if (dragStart.r() == dragEnd.r() || dragStart.c() == dragEnd.c()) {
				board.determineInlineState(dragStart, dragEnd, Board.LINE);
			}
		}
	}

	protected void rightDragged(Address dragStart, Address dragEnd) {
		if (isProblemEditMode()) {

		} else {
			if (dragStart.r() == dragEnd.r() || dragStart.c() == dragEnd.c()) {
				board.determineInlineState(dragStart, dragEnd, Board.UNKNOWN);
			}
		}
	}

	@Override
	protected void rightPressed(Address pos) {
		if (isProblemEditMode()) {
			//邩ǂ`FbN܂
			if (board.exist(pos.r(), pos.c())) {
				board.clear(pos.r(), pos.c());
			} else {
				board.setStart(pos.r(), pos.c());
			}
		}
	}

	/*
	 * uX[vL[
	 */
	protected void numberEntered(Address pos, int num) {
		if (isProblemEditMode()) {
			board.enterNumber(pos.r(), pos.c(), num);
		}
	}

	protected void spaceEntered(Address pos) {
		if (isProblemEditMode()) {
			board.clear(pos.r(), pos.c());
		}
	}

	protected void minusEntered(Address pos) {
		if (isProblemEditMode()) {
			board.setStart(pos.r(), pos.c());
		}
	}
}
