package pencilbox.slalom;

import java.io.PrintWriter;
import java.util.Iterator;

import pencilbox.common.core.BoardBase;
import pencilbox.common.core.Direction;
import pencilbox.common.io.TxtWriterBase;


/**
 *
 */
public class TxtWriter extends TxtWriterBase {

	public void writeProblem(PrintWriter out, BoardBase puzzleBoard, int mode) {
		Board board = (Board) puzzleBoard;
		int st;
		//TCYo
		out.println(board.rows());
		out.println(board.cols());
		//܂͔Ֆʂo͂܂
		for(int r=0; r<board.rows(); r++){
			for(int c=0; c<board.cols(); c++){
				st = board.getNumber(r,c);
				if (st == Board.BLANK) {
					out.print('.');
				} else if (st >= 0) {
					out.print(st);
				} else if (st == Board.START) {
					out.print('S');
				} else {
					out.print('.');
				}
				out.print(' ');
			}
			out.println();
		}
		//̏o͂܂
		out.println(board.getGateCount());
		Iterator<Board.Gate> iterator = board.getGateIterator();
		while (iterator.hasNext()) {
			Board.Gate gate = iterator.next();
			out.print(gate.direct);
			out.print(" ");
			out.print(gate.startRow);
			out.print(" ");
			out.print(gate.startCol);
			out.print(" ");
			out.print(gate.endRow);
			out.print(" ");
			out.print(gate.endCol);
			out.println();
		}
		if (mode == QUESTION_ONLY)
			return;
		for(int r=0; r<board.rows(); r++){
			for(int c=0; c<board.cols()-1; c++){
				out.print(board.getState(Direction.VERT,r,c));
				out.print(' ');
			}
			out.println();
		}
		for(int r=0; r<board.rows()-1; r++){
			for(int c=0; c<board.cols(); c++){
				out.print(board.getState(Direction.HORIZ,r,c));
				out.print(' ');
			}
			out.println();
		}

	}
}
